Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 2036)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 2037)
@@ -4333,9 +4363,9 @@
                    fd_1   = (  w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )     &
                         -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )      &
-                            ) * adv_sca_1 
+                            ) * adv_sca_1 * rho_air_zw(k)
 
                    ft_1   = (  w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )       &
                         -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )        &
-                            ) * adv_sca_1 
+                            ) * adv_sca_1 * rho_air_zw(k)
 !
 !--                Calculate ratio of upwind gradients. Note, Min/Max is just
@@ -4447,5 +4477,5 @@
                                          + IBITS(wall_flags_0(k,j,i-1),2,1)    &
                                          )                                     &
-                          ) * ddx                                              &
+                          ) * rho_air(k) * ddx                                 &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
                           - v(k,j,i)   * ( IBITS(wall_flags_0(k,j-1,i),3,1)    &
@@ -4453,7 +4483,9 @@
                                          + IBITS(wall_flags_0(k,j-1,i),5,1)    &
                                          )                                     &
-                          ) * ddy                                              &
-                        + ( w(k,j,i)   * ( ibit6 + ibit7 + ibit8 )             &
-                          - w(k-1,j,i) * ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
+                          ) * rho_air(k) * ddy                                 &
+                        + ( w(k,j,i) * rho_air_zw(k) *                         &
+                                         ( ibit6 + ibit7 + ibit8 )             &
+                          - w(k-1,j,i) * rho_air_zw(k-1) *                     &
+                                         ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
                                          + IBITS(wall_flags_0(k-1,j,i),7,1)    &
                                          + IBITS(wall_flags_0(k-1,j,i),8,1)    &
@@ -4465,5 +4497,7 @@
                                ( flux_r + diss_r - flux_l - diss_l ) * ddx    &
                              + ( flux_n + diss_n - flux_s - diss_s ) * ddy    &
-                             + ( flux_t + diss_t - flux_d - diss_d ) * ddzw(k)&
+                             + ( ( flux_t + diss_t ) -                        &
+                                 ( flux_d + diss_d )                          &
+                                                    ) * drho_air(k) * ddzw(k) &
                                 ) + div * sk(k,j,i)
 
@@ -4511,5 +4545,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -4780,5 +4814,5 @@
 
                 w_comp    = w(k,j,i) + w(k,j,i-1)
-                flux_t(k) = w_comp  * (                                      &
+                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
                           ( 37.0_wp * ibit17 * adv_mom_5                        &
                        +     7.0_wp * ibit16 * adv_mom_3                        &
@@ -4795,5 +4829,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * (                              &
+                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
                           ( 10.0_wp * ibit17 * adv_mom_5                        &
                        +     3.0_wp * ibit16 * adv_mom_3                        &
@@ -4818,6 +4852,6 @@
                                       + IBITS(wall_flags_0(k,j,i-1),10,1)     &
                                       + IBITS(wall_flags_0(k,j,i-1),11,1)     &
-                                      )                                       &   
-                  ) * ddx                                                     &
+                                      )                                       &
+                  ) * rho_air(k) * ddx                                        &
                +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
@@ -4826,7 +4860,7 @@
                                       + IBITS(wall_flags_0(k,j-1,i),14,1)     &
                                       )                                       &
-                  ) * ddy                                                     &
-               +  ( w_comp          * ( ibit15 + ibit16 + ibit17 )            &
-                - ( w(k-1,j,i) + w(k-1,j,i-1) )                               &
+                  ) * rho_air(k) * ddy                                        &
+               +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
+                - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
                                     * ( IBITS(wall_flags_0(k-1,j,i),15,1)     &
                                       + IBITS(wall_flags_0(k-1,j,i),16,1)     &
@@ -4843,7 +4877,7 @@
                + ( flux_n(k) + diss_n(k)                                       &
                -   swap_flux_y_local_u(k)   - swap_diss_y_local_u(k)   ) * ddy &
-               + ( flux_t(k) + diss_t(k)                                       &
-               -   flux_d    - diss_d                                          &
-                                                                  ) * ddzw(k)  &
+               + ( ( flux_t(k) + diss_t(k) )                                   &
+               -   ( flux_d    + diss_d    )                                   &
+                                                    ) * drho_air(k) * ddzw(k)  &
                                            ) + div * u(k,j,i)
 
@@ -4911,5 +4945,5 @@
 
                 w_comp    = w(k,j,i) + w(k,j,i-1)
-                flux_t(k) = w_comp  * (                                      &
+                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
                           ( 37.0_wp * ibit17 * adv_mom_5                        &
                        +     7.0_wp * ibit16 * adv_mom_3                        &
@@ -4926,5 +4960,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * (                              &
+                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
                           ( 10.0_wp * ibit17 * adv_mom_5                        &
                        +     3.0_wp * ibit16 * adv_mom_3                        &
@@ -4945,7 +4979,10 @@
 !--             by a not sufficient reduction of divergences near topography.
                 div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx &
+                                                                  * rho_air(k)&
                      +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy &
-                     +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) )       &
-                                                                    * ddzw(k) &
+                                                                  * rho_air(k)&
+                     +  (   w_comp                      * rho_air_zw(k) -     &
+                          ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)     &
+                        ) * ddzw(k)                                           &
                       ) * 0.5_wp
 
@@ -4955,7 +4992,7 @@
                + ( flux_n(k) + diss_n(k)                                       &
                -   swap_flux_y_local_u(k)   - swap_diss_y_local_u(k)   ) * ddy &
-               + ( flux_t(k) + diss_t(k)                                       &
-               -   flux_d    - diss_d                                          &
-                                                                  ) * ddzw(k)  &
+               + ( ( flux_t(k) + diss_t(k) )                                   &
+               -   ( flux_d    + diss_d    )                                   &
+                                                    ) * drho_air(k) * ddzw(k)  &
                                            ) + div * u(k,j,i)
 
@@ -5004,5 +5041,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -5267,5 +5304,5 @@
 
                 w_comp    = w(k,j,i) + w(k,j,i-1)
-                flux_t    = w_comp  * (                                      &
+                flux_t    = w_comp * rho_air_zw(k) * (                       &
                           ( 37.0_wp * ibit17 * adv_mom_5                        &
                        +     7.0_wp * ibit16 * adv_mom_3                        &
@@ -5282,5 +5319,5 @@
                                       )
 
-                diss_t    = - ABS( w_comp ) * (                              &
+                diss_t    = - ABS( w_comp ) * rho_air_zw(k) * (              &
                           ( 10.0_wp * ibit17 * adv_mom_5                        &
                        +     3.0_wp * ibit16 * adv_mom_3                        &
@@ -5305,6 +5342,6 @@
                                       + IBITS(wall_flags_0(k,j,i-1),10,1)     &
                                       + IBITS(wall_flags_0(k,j,i-1),11,1)     &
-                                      )                                       &   
-                  ) * ddx                                                     &
+                                      )                                       &
+                  ) * rho_air(k) * ddx                                        &
                +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
@@ -5313,11 +5350,11 @@
                                       + IBITS(wall_flags_0(k,j-1,i),14,1)     &
                                       )                                       &
-                  ) * ddy                                                     &
-               +  ( w_comp          * ( ibit15 + ibit16 + ibit17 )            &
-                - ( w(k-1,j,i) + w(k-1,j,i-1) )                               &
+                  ) * rho_air(k) * ddy                                        &
+               +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
+                - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
                                     * ( IBITS(wall_flags_0(k-1,j,i),15,1)     &
                                       + IBITS(wall_flags_0(k-1,j,i),16,1)     &
                                       + IBITS(wall_flags_0(k-1,j,i),17,1)     &
-                                      )                                       &  
+                                      )                                       &
                   ) * ddzw(k)   &
                 ) * 0.5_wp
@@ -5327,5 +5364,7 @@
                                ( flux_r + diss_r - flux_l - diss_l ) * ddx     &
                              + ( flux_n + diss_n - flux_s - diss_s ) * ddy     &
-                             + ( flux_t + diss_t - flux_d - diss_d ) * ddzw(k) &
+                             + ( ( flux_t + diss_t ) -                         &
+                                 ( flux_d + diss_d )                           &
+                                                     ) * drho_air(k) * ddzw(k) &
                                 ) + div * u(k,j,i)
 
@@ -5365,5 +5404,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -5633,5 +5672,5 @@
 
                 w_comp    = w(k,j-1,i) + w(k,j,i)
-                flux_t(k) = w_comp  * (                                      &
+                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
                           ( 37.0_wp * ibit26 * adv_mom_5                        &
                        +     7.0_wp * ibit25 * adv_mom_3                        &
@@ -5648,5 +5687,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * (                              &
+                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
                           ( 10.0_wp * ibit26 * adv_mom_5                        &
                        +     3.0_wp * ibit25 * adv_mom_3                        &
@@ -5672,6 +5711,6 @@
                                          + IBITS(wall_flags_0(k,j,i-1),19,1)  &
                                          + IBITS(wall_flags_0(k,j,i-1),20,1)  &
-                                         )                                    &   
-                  ) * ddx                                                     &
+                                         )                                    &
+                  ) * rho_air(k) * ddx                                        &
                +  ( v_comp(k)                                                 &
                                        * ( ibit21 + ibit22 + ibit23 )         &
@@ -5680,9 +5719,9 @@
                                          + IBITS(wall_flags_0(k,j-1,i),22,1)  &
                                          + IBITS(wall_flags_0(k,j-1,i),23,1)  &
-                                         )                                    &   
-                  ) * ddy                                                     &
-               +  ( w_comp                                                    &
+                                         )                                    &
+                  ) * rho_air(k) * ddy                                        &
+               +  ( w_comp * rho_air_zw(k)                                    &
                                        * ( ibit24 + ibit25 + ibit26 )         &
-                - ( w(k-1,j-1,i) + w(k-1,j,i) )                               &
+                - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)             &
                                        * ( IBITS(wall_flags_0(k-1,j,i),24,1)  &
                                          + IBITS(wall_flags_0(k-1,j,i),25,1)  &
@@ -5700,7 +5739,7 @@
                      -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)      &
                        ) * ddy                                                &
-                     + ( flux_t(k) + diss_t(k)                                &
-                     -   flux_d    - diss_d                                   &
-                       ) * ddzw(k)                                            &
+                     + ( ( flux_t(k) + diss_t(k) )                            &
+                     -   ( flux_d    + diss_d    )                            &
+                       ) * drho_air(k) * ddzw(k)                              &
                                             )  + v(k,j,i) * div
 
@@ -5772,5 +5811,5 @@
 
                 w_comp    = w(k,j-1,i) + w(k,j,i)
-                flux_t(k) = w_comp  * (                                      &
+                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
                           ( 37.0_wp * ibit26 * adv_mom_5                        &
                        +     7.0_wp * ibit25 * adv_mom_3                        &
@@ -5787,5 +5826,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * (                              &
+                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
                           ( 10.0_wp * ibit26 * adv_mom_5                        &
                        +     3.0_wp * ibit25 * adv_mom_3                        &
@@ -5806,7 +5845,10 @@
 !--             by a not sufficient reduction of divergences near topography.
                 div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx &
+                                                                  * rho_air(k)&
                      +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy &
-                     +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) ) )       &
-                                                                    * ddzw(k) &
+                                                                  * rho_air(k)&
+                     +  (   w_comp                      * rho_air_zw(k) -     &
+                          ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)     &
+                        ) * ddzw(k)                                           &
                       ) * 0.5_wp
  
@@ -5818,7 +5860,7 @@
                      -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)      &
                        ) * ddy                                                &
-                     + ( flux_t(k) + diss_t(k)                                &
-                     -   flux_d    - diss_d                                   &
-                       ) * ddzw(k)                                            &
+                     + ( ( flux_t(k) + diss_t(k) )                            &
+                     -   ( flux_d    + diss_d    )                            &
+                       ) * drho_air(k) * ddzw(k)                              &
                                             )  + v(k,j,i) * div
 
@@ -5869,5 +5911,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -6132,5 +6174,5 @@
 
                 w_comp    = w(k,j-1,i) + w(k,j,i)
-                flux_t    = w_comp  * (                                      &
+                flux_t    = w_comp * rho_air_zw(k) * (                       &
                           ( 37.0_wp * ibit26 * adv_mom_5                        &
                        +     7.0_wp * ibit25 * adv_mom_3                        &
@@ -6147,5 +6189,5 @@
                                       )
 
-                diss_t    = - ABS( w_comp ) * (                              &
+                diss_t    = - ABS( w_comp ) * rho_air_zw(k) * (              &
                           ( 10.0_wp * ibit26 * adv_mom_5                        &
                        +     3.0_wp * ibit25 * adv_mom_3                        &
@@ -6171,6 +6213,6 @@
                                          + IBITS(wall_flags_0(k,j,i-1),19,1)  &
                                          + IBITS(wall_flags_0(k,j,i-1),20,1)  &
-                                         )                                    &   
-                  ) * ddx                                                     &
+                                         )                                    &
+                  ) * rho_air(k) * ddx                                        &
                +  ( v_comp                                                    &
                                        * ( ibit21 + ibit22 + ibit23 )         &
@@ -6179,9 +6221,9 @@
                                          + IBITS(wall_flags_0(k,j-1,i),22,1)  &
                                          + IBITS(wall_flags_0(k,j-1,i),23,1)  &
-                                         )                                    &   
-                  ) * ddy                                                     &
-               +  ( w_comp                                                    &
+                                         )                                    &
+                  ) * rho_air(k) * ddy                                        &
+               +  ( w_comp * rho_air_zw(k)                                    &
                                        * ( ibit24 + ibit25 + ibit26 )         &
-                - ( w(k-1,j-1,i) + w(k-1,j,i) )                               &
+                - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)             &
                                        * ( IBITS(wall_flags_0(k-1,j,i),24,1)  &
                                          + IBITS(wall_flags_0(k-1,j,i),25,1)  &
@@ -6195,5 +6237,7 @@
                                ( flux_r + diss_r - flux_l - diss_l ) * ddx     &
                              + ( flux_n + diss_n - flux_s - diss_s ) * ddy     &
-                             + ( flux_t + diss_t - flux_d - diss_d ) * ddzw(k) &
+                             + ( ( flux_t + diss_t ) -                         &
+                                 ( flux_d + diss_d )                           &
+                               ) * drho_air(k) * ddzw(k)                       &
                                 ) + div * v(k,j,i)
 
@@ -6235,5 +6279,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, tend, u, v, w
+           ONLY:  ddzu, drho_air_zw, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -6509,5 +6553,5 @@
 
                 w_comp    = w(k+1,j,i) + w(k,j,i)
-                flux_t(k) = w_comp  * (                                      &
+                flux_t(k) = w_comp * rho_air(k+1) * (                        &
                           ( 37.0_wp * ibit35 * adv_mom_5                        &
                        +     7.0_wp * ibit34 * adv_mom_3                        &
@@ -6524,5 +6568,5 @@
                                        )
 
-                diss_t(k) = - ABS( w_comp ) * (                              &
+                diss_t(k) = - ABS( w_comp ) * rho_air(k+1) * (               &
                           ( 10.0_wp * ibit35 * adv_mom_5                        &
                        +     3.0_wp * ibit34 * adv_mom_3                        &
@@ -6548,6 +6592,6 @@
                                       + IBITS(wall_flags_0(k,j,i-1),29,1)     &
                                       )                                       &
-                  ) * ddx                                                     &
-              +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            & 
+                  ) * rho_air_zw(k) * ddx                                     &
+              +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            &
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
                                     * ( IBITS(wall_flags_0(k,j-1,i),30,1)     &
@@ -6555,7 +6599,7 @@
                                       + IBITS(wall_flags_00(k,j-1,i),0,1)     &
                                       )                                       &
-                  ) * ddy                                                     &
-              +   ( w_comp          * ( ibit33 + ibit34 + ibit35 )            &
-                - ( w(k,j,i)   + w(k-1,j,i)   )                               &
+                  ) * rho_air_zw(k) * ddy                                     &
+              +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
+                - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
                                     * ( IBITS(wall_flags_00(k-1,j,i),1,1)     &
                                       + IBITS(wall_flags_00(k-1,j,i),2,1)     &
@@ -6574,7 +6618,7 @@
                     -   swap_flux_y_local_w(k)   - swap_diss_y_local_w(k)     &
                       ) * ddy                                                 &
-                    + ( flux_t(k) + diss_t(k)                                 &
-                    -   flux_d    - diss_d                                    &
-                      ) * ddzu(k+1)                                           &
+                    + ( ( flux_t(k) + diss_t(k) )                             &
+                    -   ( flux_d    + diss_d    )                             &
+                      ) * drho_air_zw(k) * ddzu(k+1)                          &
                                             )  + div * w(k,j,i)
 
@@ -6632,5 +6676,5 @@
 
                 w_comp    = w(k+1,j,i) + w(k,j,i)
-                flux_t(k) = w_comp  * (                                      &
+                flux_t(k) = w_comp * rho_air(k+1) * (                        &
                           ( 37.0_wp * ibit35 * adv_mom_5                        &
                        +     7.0_wp * ibit34 * adv_mom_3                        &
@@ -6647,5 +6691,5 @@
                                        )
 
-                diss_t(k) = - ABS( w_comp ) * (                              &
+                diss_t(k) = - ABS( w_comp ) * rho_air(k+1) * (               &
                           ( 10.0_wp * ibit35 * adv_mom_5                        &
                        +     3.0_wp * ibit34 * adv_mom_3                        &
@@ -6666,7 +6710,10 @@
 !--             by a not sufficient reduction of divergences near topography.
                 div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx  &
+                                                             * rho_air_zw(k) &
                     +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy  &
-                    +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) )        &
-                                                                 * ddzu(k+1) &
+                                                             * rho_air_zw(k) &
+                    +   (   w_comp                    * rho_air(k+1) -       &
+                          ( w(k,j,i)   + w(k-1,j,i) ) * rho_air(k)           &
+                        ) * ddzu(k+1)                                        &
                       ) * 0.5_wp
 
@@ -6678,7 +6725,7 @@
                     -   swap_flux_y_local_w(k)   - swap_diss_y_local_w(k)     &
                       ) * ddy                                                 &
-                    + ( flux_t(k) + diss_t(k)                                 &
-                    -   flux_d    - diss_d                                    &
-                      ) * ddzu(k+1)                                           &
+                    + ( ( flux_t(k) + diss_t(k) )                             &
+                    -   ( flux_d    + diss_d    )                             &
+                      ) * drho_air_zw(k) * ddzu(k+1)                          &
                                             )  + div * w(k,j,i)
 
@@ -6714,5 +6761,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, tend, u, v, w
+           ONLY:  ddzu, drho_air_zw, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -6976,5 +7023,5 @@
 
                 w_comp    = w(k+1,j,i) + w(k,j,i)
-                flux_t    = w_comp  * (                                      &
+                flux_t    = w_comp * rho_air(k+1) * (                        &
                           ( 37.0_wp * ibit35 * adv_mom_5                        &
                        +     7.0_wp * ibit34 * adv_mom_3                        &
@@ -6991,5 +7038,5 @@
                                        )
 
-                diss_t    = - ABS( w_comp ) * (                              &
+                diss_t    = - ABS( w_comp ) * rho_air(k+1) * (               &
                           ( 10.0_wp * ibit35 * adv_mom_5                        &
                        +     3.0_wp * ibit34 * adv_mom_3                        &
@@ -7015,6 +7062,6 @@
                                       + IBITS(wall_flags_0(k,j,i-1),29,1)     &
                                       )                                       &
-                  ) * ddx                                                     &
-              +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            & 
+                  ) * rho_air_zw(k) * ddx                                     &
+              +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            &
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
                                     * ( IBITS(wall_flags_0(k,j-1,i),30,1)     &
@@ -7022,7 +7069,7 @@
                                       + IBITS(wall_flags_00(k,j-1,i),0,1)     &
                                       )                                       &
-                  ) * ddy                                                     &
-              +   ( w_comp          * ( ibit33 + ibit34 + ibit35 )            &
-                - ( w(k,j,i)   + w(k-1,j,i)   )                               &
+                  ) * rho_air_zw(k) * ddy                                     &
+              +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
+                - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
                                     * ( IBITS(wall_flags_00(k-1,j,i),1,1)     &
                                       + IBITS(wall_flags_00(k-1,j,i),2,1)     &
@@ -7036,5 +7083,7 @@
                                ( flux_r + diss_r - flux_l - diss_l ) * ddx       &
                              + ( flux_n + diss_n - flux_s - diss_s ) * ddy       &
-                             + ( flux_t + diss_t - flux_d - diss_d ) * ddzu(k+1) &
+                             + ( ( flux_t + diss_t ) -                           &
+                                 ( flux_d + diss_d ) * rho_air(k)                &
+                               ) * drho_air_zw(k) * ddzu(k+1)                    &
                                  ) + div * w(k,j,i)
 
